Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ASM/asminc.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ASM/asminc.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ASM/asminc.F90	(revision 3211)
@@ -75,4 +75,9 @@
 
    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::   ssh_bkg, ssh_bkginc   ! Background sea surface height and its increment
+
+   !! * Control permutation of array indices
+#  include "asminc_ftrans.h90"
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
 
    !!----------------------------------------------------------------------
@@ -409,5 +414,9 @@
             CALL iom_get( inum, jpdom_autoglo, 'bckineta', ssh_bkginc, 1 )
             ! Apply the masks
+#if defined key_z_first
+            ssh_bkginc(:,:) = ssh_bkginc(:,:) * tmask_1(:,:)
+#else
             ssh_bkginc(:,:) = ssh_bkginc(:,:) * tmask(:,:,1)
+#endif
             ! Set missing increments to 0.0 rather than 1e+20
             ! to allow for differences in masks
@@ -472,5 +481,9 @@
          IF ( ln_sshinc ) THEN
             CALL iom_get( inum, jpdom_autoglo, 'sshn', ssh_bkg )
+#if defined key_z_first
+            ssh_bkg(:,:) = ssh_bkg(:,:) * tmask_1(:,:)
+#else
             ssh_bkg(:,:) = ssh_bkg(:,:) * tmask(:,:,1)
+#endif
          ENDIF
 
@@ -620,14 +633,31 @@
 
             ! Update the tracer tendencies
+#if defined key_z_first
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  DO jk = 1, jpkm1
+                     tsa(ji,jj,jk,jp_tem) = tsa(ji,jj,jk,jp_tem) + t_bkginc(ji,jj,jk) * zincwgt  
+                     tsa(ji,jj,jk,jp_sal) = tsa(ji,jj,jk,jp_sal) + s_bkginc(ji,jj,jk) * zincwgt
+                  END DO
+               END DO
+            END DO
+#else
             DO jk = 1, jpkm1
                tsa(:,:,jk,jp_tem) = tsa(:,:,jk,jp_tem) + t_bkginc(:,:,jk) * zincwgt  
                tsa(:,:,jk,jp_sal) = tsa(:,:,jk,jp_sal) + s_bkginc(:,:,jk) * zincwgt
             END DO
+#endif
 
             ! Salinity fix
             IF (ln_salfix) THEN
+#if defined key_z_first
+               DO jj = 1, jpj
+                  DO ji= 1, jpi
+                     DO jk = 1, jpkm1
+#else
                DO jk = 1, jpkm1
                   DO jj = 1, jpj
                      DO ji= 1, jpi
+#endif
                         tsa(ji,jj,jk,jp_sal) = MAX( tsa(ji,jj,jk,jp_sal), salfixmin )
                      END DO
@@ -660,7 +690,13 @@
             ! Optional salinity fix
             IF (ln_salfix) THEN
+#if defined key_z_first
+               DO jj = 1, jpj
+                  DO ji= 1, jpi
+                     DO jk = 1, jpkm1
+#else
                DO jk = 1, jpkm1
                   DO jj = 1, jpj
                      DO ji= 1, jpi
+#endif
                         tsn(ji,jj,jk,jp_sal) = MAX( tsn(ji,jj,jk,jp_sal), salfixmin )
                      END DO
@@ -702,4 +738,7 @@
       !
       INTEGER :: jk
+#if defined key_z_first
+      INTEGER :: ji, jj
+#endif
       INTEGER :: it
       REAL(wp) :: zincwgt  ! IAU weight for current time step
@@ -725,8 +764,20 @@
 
             ! Update the dynamic tendencies
+
+#if defined key_z_first
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  DO jk = 1, jpkm1
+                     ua(ji,jj,jk) = ua(ji,jj,jk) + u_bkginc(ji,jj,jk) * zincwgt
+                     va(ji,jj,jk) = va(ji,jj,jk) + v_bkginc(ji,jj,jk) * zincwgt
+                  END DO
+               END DO
+            END DO
+#else
             DO jk = 1, jpkm1
                ua(:,:,jk) = ua(:,:,jk) + u_bkginc(:,:,jk) * zincwgt
                va(:,:,jk) = va(:,:,jk) + v_bkginc(:,:,jk) * zincwgt
             END DO
+#endif
            
             IF ( kt == nitiaufin_r ) THEN
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ASM/asminc_ftrans.h90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ASM/asminc_ftrans.h90	(revision 3211)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ASM/asminc_ftrans.h90	(revision 3211)
@@ -0,0 +1,27 @@
+   !!----------------------------------------------------------------------
+   !!                   ***  asminc_ftrans  ***
+   !!----------------------------------------------------------------------
+   !! ** purpose : FTRANS directives to control permutation of array indices
+   !!   for multi-dimensional arrays with a z-dimension declared in module
+   !!   asminc.  It should be included wherever the module is used,
+   !!   and updated whenever a new array is added to the module.
+   !!----------------------------------------------------------------------
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2011)
+   !! $Id$
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+#if defined key_z_first
+!FTRANS assert :z :I
+#else
+!FTRANS assert :I :z
+#endif
+!FTRANS t_bkg :I :I :z
+!FTRANS s_bkg :I :I :z
+!FTRANS u_bkg :I :I :z
+!FTRANS v_bkg :I :I :z
+!FTRANS t_bkginc :I :I :z 
+!FTRANS s_bkginc :I :I :z 
+!FTRANS u_bkginc :I :I :z 
+!FTRANS v_bkginc :I :I :z 
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ASM/asmtrj.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ASM/asmtrj.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/ASM/asmtrj.F90	(revision 3211)
@@ -50,4 +50,16 @@
    PUBLIC   asm_trj_wri   !: Write out the background state
 
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+#  include "zdfddm_ftrans.h90"
+#  include "ldftra_oce_ftrans.h90"
+#  include "ldfslp_ftrans.h90"
+#  include "tradmp_ftrans.h90"
+#if defined key_zdftke
+#  include "zdftke_ftrans.h90"
+#endif
+
    !!----------------------------------------------------------------------
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90	(revision 3211)
@@ -41,5 +41,5 @@
    !
    INTEGER ::   nn_rimwidth = 7       !: boundary rim width
-   INTEGER ::   nn_dtactl   = 1	     !: = 0 use the initial state as bdy dta ; = 1 read it in a NetCDF file
+   INTEGER ::   nn_dtactl   = 1       !: = 0 use the initial state as bdy dta ; = 1 read it in a NetCDF file
    INTEGER ::   nn_volctl   = 1       !: = 0 the total volume will have the variability of the surface Flux E-P 
    !                                  !  = 1 the volume will be constant during all the integration.
@@ -63,5 +63,5 @@
    INTEGER, DIMENSION(jpbdim,jpbgrd) ::   nbmap           !: Indices of data in file for data in memory 
     
-   REAL(wp) ::   bdysurftot	                            !: Lateral surface of unstructured open boundary
+   REAL(wp) ::   bdysurftot                               !: Lateral surface of unstructured open boundary
 
    REAL(wp), DIMENSION(jpbdim)        ::   flagu, flagv   !: Flag for normal velocity compnt for velocity components
@@ -71,5 +71,5 @@
    REAL(wp), DIMENSION(jpbdim)     ::   ubtbdy, vbtbdy    !: Now clim of bdy barotropic velocity components
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) ::   tbdy  , sbdy      !: Now clim of bdy temperature and salinity  
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) ::   ubdy  , vbdy	  !: Now clim of bdy velocity components
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) ::   ubdy  , vbdy      !: Now clim of bdy velocity components
    REAL(wp), DIMENSION(jpbdim) ::   sshtide               !: Tidal boundary array : SSH
    REAL(wp), DIMENSION(jpbdim) ::   utide, vtide          !: Tidal boundary array : U and V
@@ -79,4 +79,7 @@
    REAL(wp), DIMENSION(jpbdim) ::   hsnif_bdy   !: now snow thickness
 #endif
+
+   !! * Control permutation of array indices
+   !!   We do not permute indices of boundary condition arrays!
 
    !!----------------------------------------------------------------------
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90	(revision 3211)
@@ -58,4 +58,8 @@
    REAL(wp), DIMENSION(jpbdim,2)     ::   hsnif_bdydta         ! }
 #endif
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
 
    !!----------------------------------------------------------------------
@@ -114,4 +118,5 @@
       REAL(wp) ::   dayjul0, zdayjulini
       REAL(wp), DIMENSION(jpbtime)      ::   zstepr             ! REAL time array from data files
+!! DCSE_NEMO: do not ftrans! Beware!
       REAL(wp), DIMENSION(jpbdta,1,jpk) ::   zdta               ! temporary array for data fields
       !!---------------------------------------------------------------------------
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/BDY/bdydyn.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/BDY/bdydyn.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/BDY/bdydyn.F90	(revision 3211)
@@ -35,4 +35,8 @@
 # endif
 
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+
    !!----------------------------------------------------------------------
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
@@ -133,5 +137,5 @@
       ! Flather boundary conditions     :!
       ! ---------------------------------! 
-     
+
       IF(ln_dyn_fla .OR. ln_tides) THEN ! If these are both false, then this routine does nothing. 
 
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/BDY/bdyice.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/BDY/bdyice.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/BDY/bdyice.F90	(revision 3211)
@@ -25,4 +25,8 @@
 
    PUBLIC   bdy_ice_frs    ! routine called in sbcmod
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
 
    !!----------------------------------------------------------------------
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/BDY/bdyini.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/BDY/bdyini.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/BDY/bdyini.F90	(revision 3211)
@@ -32,4 +32,8 @@
 
    PUBLIC   bdy_init   ! routine called by opa.F90
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
 
    !!----------------------------------------------------------------------
@@ -336,7 +340,13 @@
       ! Mask corrections
       ! ----------------
+#if defined key_z_first
+      DO ij = 1, jpj
+         DO ii = 1, jpi
+            DO ik = 1, jpkm1
+#else
       DO ik = 1, jpkm1
          DO ij = 1, jpj
             DO ii = 1, jpi
+#endif
                tmask(ii,ij,ik) = tmask(ii,ij,ik) * bdytmask(ii,ij)
                umask(ii,ij,ik) = umask(ii,ij,ik) * bdyumask(ii,ij)
@@ -347,7 +357,13 @@
       END DO
 
+#if defined key_z_first
+      DO ij = 2, jpjm1
+         DO ii = 2, jpim1
+            DO ik = 1, jpkm1
+#else
       DO ik = 1, jpkm1
          DO ij = 2, jpjm1
             DO ii = 2, jpim1
+#endif
                fmask(ii,ij,ik) = fmask(ii,ij,ik) * bdytmask(ii,ij  ) * bdytmask(ii+1,ij  )   &
                   &                              * bdytmask(ii,ij+1) * bdytmask(ii+1,ij+1)
@@ -356,6 +372,11 @@
       END DO
 
+#if defined key_z_first
+      bdytmask(:,:) = tmask(:,:,1)
+      tmask_i (:,:) = bdytmask(:,:) * tmask_i(:,:)             
+#else
       tmask_i (:,:) = tmask(:,:,1) * tmask_i(:,:)             
       bdytmask(:,:) = tmask(:,:,1)
+#endif
 
       ! bdy masks and bmask are now set to zero on boundary points:
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/BDY/bdytides.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/BDY/bdytides.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/BDY/bdytides.F90	(revision 3211)
@@ -54,4 +54,8 @@
    REAL(wp), DIMENSION(jpbdim,jptides_max)  ::   u1  , u2     ! Tidal constituents : U
    REAL(wp), DIMENSION(jpbdim,jptides_max)  ::   v1  , v2     ! Tidal constituents : V
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
    
    !!----------------------------------------------------------------------
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/BDY/bdytra.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/BDY/bdytra.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/BDY/bdytra.F90	(revision 3211)
@@ -23,4 +23,8 @@
 
    PUBLIC bdy_tra_frs     ! routine called in tranxt.F90 
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
 
    !!----------------------------------------------------------------------
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/BDY/bdyvol.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/BDY/bdyvol.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/BDY/bdyvol.F90	(revision 3211)
@@ -26,4 +26,9 @@
 
    PUBLIC bdy_vol        ! routine called by dynspg_flt.h90
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
 
    !! * Substitutions
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/C1D/dyncor_c1d.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/C1D/dyncor_c1d.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/C1D/dyncor_c1d.F90	(revision 3211)
@@ -25,4 +25,8 @@
    PUBLIC   cor_c1d      ! routine called by OPA.F90
    PUBLIC   dyn_cor_c1d  ! routine called by step1d.F90
+
+   !! * Array index permutations
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
 
    !! * Substitutions
@@ -96,7 +100,13 @@
       ENDIF
       !
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 1, jpkm1
+#else
       DO jk = 1, jpkm1
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                ua(ji,jj,jk) = ua(ji,jj,jk) + ff(ji,jj) * vn(ji,jj,jk)
                va(ji,jj,jk) = va(ji,jj,jk) - ff(ji,jj) * un(ji,jj,jk)
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/C1D/dynnxt_c1d.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/C1D/dynnxt_c1d.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/C1D/dynnxt_c1d.F90	(revision 3211)
@@ -23,4 +23,7 @@
 
    PUBLIC dyn_nxt_c1d                ! routine called by step.F90
+   !! * Array index permutations
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
    !!----------------------------------------------------------------------
    !! NEMO/C1D 3.3 , NEMO Consortium (2010)
@@ -51,5 +54,9 @@
       INTEGER, INTENT( in ) ::   kt      ! ocean time-step index
       !!
+#if defined key_z_first
+      INTEGER  ::   ji, jj, jk   ! dummy loop indices
+#else
       INTEGER  ::   jk           ! dummy loop indices
+#endif
       REAL(wp) ::   z2dt         ! temporary scalar
       !!----------------------------------------------------------------------
@@ -66,9 +73,43 @@
       CALL lbc_lnk( ua, 'U', -1. )   ;   CALL lbc_lnk( va, 'V', -1. )      ! Lateral boundary conditions
 
+#if defined key_z_first
+      DO jj = 1, jpj                                                       ! Next Velocity
+         DO ji = 1, jpi 
+            DO jk = 1, jpkm1
+               ua(ji,jj,jk) = ( ub(ji,jj,jk) + z2dt * ua(ji,jj,jk) ) * umask(ji,jj,jk)
+               va(ji,jj,jk) = ( vb(ji,jj,jk) + z2dt * va(ji,jj,jk) ) * vmask(ji,jj,jk)
+            END DO
+         END DO
+      END DO 
+#else
       DO jk = 1, jpkm1                                                     ! Next Velocity
          ua(:,:,jk) = ( ub(:,:,jk) + z2dt * ua(:,:,jk) ) * umask(:,:,jk)
          va(:,:,jk) = ( vb(:,:,jk) + z2dt * va(:,:,jk) ) * vmask(:,:,jk)
       END DO 
+#endif
  
+#if defined key_z_first
+      IF( neuler == 0 .AND. kt == nit000 ) THEN                            ! Euler (forward) time stepping
+         DO jj = 1, jpj                                                    ! Time filter and swap of dynamics arrays
+            DO ji = 1, jpi
+               ub(ji,jj,1:jpkm1) = un(ji,jj,1:jpkm1)
+               vb(ji,jj,1:jpkm1) = vn(ji,jj,1:jpkm1)
+               un(ji,jj,1:jpkm1) = ua(ji,jj,1:jpkm1)
+               vn(ji,jj,1:jpkm1) = va(ji,jj,1:jpkm1)
+            END DO
+         END DO
+      ELSE                                                                ! Leap-frog time stepping
+         DO jj =1 , jpj
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+                  ub(ji,jj,jk) = atfp * ( ub(ji,jj,jk) + ua(ji,jj,jk) ) + atfp1 * un(ji,jj,jk)
+                  vb(ji,jj,jk) = atfp * ( vb(ji,jj,jk) + va(ji,jj,jk) ) + atfp1 * vn(ji,jj,jk)
+                  un(ji,jj,jk) = ua(ji,jj,jk)
+                  vn(ji,jj,jk) = va(ji,jj,jk)
+               END DO
+            END DO
+         END DO
+      ENDIF
+#else
       DO jk = 1, jpkm1                                                     ! Time filter and swap of dynamics arrays
          IF( neuler == 0 .AND. kt == nit000 ) THEN                               ! Euler (forward) time stepping
@@ -84,4 +125,5 @@
          ENDIF
       END DO
+#endif
 
       IF(ln_ctl)   CALL prt_ctl( tab3d_1=un, clinfo1=' nxt_c1d  - Un: ', mask1=umask,   &
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/C1D/step_c1d.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/C1D/step_c1d.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/C1D/step_c1d.F90	(revision 3211)
@@ -24,4 +24,8 @@
 
    PUBLIC stp_c1d      ! called by opa.F90
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
 
    !! * Substitutions
@@ -53,5 +57,9 @@
       !!----------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kstp   ! ocean time-step index
-      INTEGER ::   jk       ! dummy loop indice
+#if defined key_z_first
+      INTEGER ::   ji, jj, jk         ! dummy loop indices
+#else
+      INTEGER ::   jk                 ! dummy loop index
+#endif
       INTEGER ::   indic    ! error indicator if < 0
       !! ---------------------------------------------------------------------
@@ -87,5 +95,15 @@
 
       IF( ln_rnf_mouth ) THEN                         ! increase diffusivity at rivers mouths
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 2, nkrnf
+                  avt(ji,jj,jk) = avt(ji,jj,jk) + 2.e0 * rn_avt_rnf * rnfmsk(ji,jj)
+               END DO
+            END DO
+         END DO
+#else
          DO jk = 2, nkrnf   ;   avt(:,:,jk) = avt(:,:,jk) + 2.e0 * rn_avt_rnf * rnfmsk(:,:)   ;   END DO
+#endif
       ENDIF
       IF( ln_zdfevd  )   CALL zdf_evd( kstp )         ! enhanced vertical eddy diffusivity
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DIA/diaar5.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DIA/diaar5.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DIA/diaar5.F90	(revision 3211)
@@ -7,4 +7,5 @@
    !!            3.3  !  2010-10  (C. Ethe, G. Madec) reorganisation of initialisation phase + merge TRC-TRA
    !!----------------------------------------------------------------------
+
 #if defined key_diaar5   || defined key_esopa
    !!----------------------------------------------------------------------
@@ -17,5 +18,5 @@
    USE dom_oce        ! ocean space and time domain
    USE eosbn2         ! equation of state                (eos_bn2 routine)
-   USE lib_mpp        ! distribued memory computing library
+   USE lib_mpp        ! distributed memory computing library
    USE iom            ! I/O manager library
 
@@ -35,4 +36,9 @@
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   sn0          ! initial salinity
       
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+!FTRANS sn0 :I :I :z
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -69,4 +75,9 @@
       USE wrk_nemo, ONLY:   zrhd      => wrk_3d_1 , zrhop    => wrk_3d_2   ! 3D      -
       USE wrk_nemo, ONLY:   ztsn      => wrk_4d_1                          ! 4D      -
+
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS zrhd zrhop :I :I :z
+!FTRANS ztsn :I :I :z :
+
       !
       INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
@@ -99,8 +110,18 @@
       CALL eos( ztsn, zrhd )                       ! now in situ density using initial salinity
       !
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            zbotpres(ji,jj) = 0._wp                ! no atmospheric surface pressure, levitating sea-ice
+            DO jk = 1, jpkm1
+               zbotpres(ji,jj) = zbotpres(ji,jj) + fse3t(ji,jj,jk) * zrhd(ji,jj,jk)
+            END DO
+      END DO
+#else
       zbotpres(:,:) = 0._wp                        ! no atmospheric surface pressure, levitating sea-ice
       DO jk = 1, jpkm1
          zbotpres(:,:) = zbotpres(:,:) + fse3t(:,:,jk) * zrhd(:,:,jk)
       END DO
+#endif
       IF( .NOT.lk_vvl )   zbotpres(:,:) = zbotpres(:,:) + sshn(:,:) * zrhd(:,:,1)
       !                                         
@@ -115,8 +136,18 @@
       CALL iom_put( 'rhop', zrhop )
       !
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            zbotpres(ji,jj) = 0._wp                ! no atmospheric surface pressure, levitating sea-ice
+            DO jk = 1, jpkm1
+               zbotpres(ji,jj) = zbotpres(ji,jj) + fse3t(ji,jj,jk) * zrhd(ji,jj,jk)
+            END DO
+      END DO
+#else
       zbotpres(:,:) = 0._wp                        ! no atmospheric surface pressure, levitating sea-ice
       DO jk = 1, jpkm1
          zbotpres(:,:) = zbotpres(:,:) + fse3t(:,:,jk) * zrhd(:,:,jk)
       END DO
+#endif
       IF( .NOT.lk_vvl )   zbotpres(:,:) = zbotpres(:,:) + sshn(:,:) * zrhd(:,:,1)
       !    
@@ -134,7 +165,13 @@
       ztemp = 0._wp
       zsal  = 0._wp
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            DO jk = 1, jpkm1
+#else
       DO jk = 1, jpkm1
          DO jj = 1, jpj
             DO ji = 1, jpi
+#endif
                zztmp = area(ji,jj) * fse3t(ji,jj,jk)
                ztemp = ztemp + zztmp * tn(ji,jj,jk)
@@ -166,4 +203,8 @@
    END SUBROUTINE dia_ar5
 
+   !! * Reset control of array index permutation
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+!FTRANS sn0 :I :I :z
 
    SUBROUTINE dia_ar5_init
@@ -181,4 +222,5 @@
       REAL(wp) ::   zztmp  
       REAL(wp), POINTER, DIMENSION(:,:,:,:) ::   zsaldta   ! Jan/Dec levitus salinity
+!FTRANS zsaldta :I :I :z :
       !!----------------------------------------------------------------------
       !
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DIA/diadimg.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DIA/diadimg.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DIA/diadimg.F90	(revision 3211)
@@ -22,4 +22,8 @@
    REAL(sp), ALLOCATABLE, SAVE, DIMENSION(:,:) :: z42d    ! 2d temporary workspace (sp)
    REAL(sp), ALLOCATABLE, SAVE, DIMENSION(:)   :: z4dep   ! vertical level (sp)
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
 
    !! * Substitutions
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DIA/diafwb.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DIA/diafwb.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DIA/diafwb.F90	(revision 3211)
@@ -33,4 +33,10 @@
       &                        a_sshb, a_sshn, a_salb, a_saln
    REAL(wp), DIMENSION(4) ::   a_flxi, a_flxo, a_temi, a_temo, a_sali, a_salo
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
 
    !! * Substitutions
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DIA/diahsb.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DIA/diahsb.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DIA/diahsb.F90	(revision 3211)
@@ -19,5 +19,8 @@
    USE trabbc          ! bottom boundary condition
    USE bdy_par         ! (for lk_bdy)
-   USE obc_par         ! (for lk_obc)
+
+!! DCSE_NEMO:
+!  USE obc_par         ! (for lk_obc)
+   USE obc_par, ONLY: lk_obc         ! (for lk_obc)
 
    IMPLICIT NONE
@@ -37,4 +40,11 @@
    REAL(dp), DIMENSION(:,:)  , ALLOCATABLE ::   surf      , ssh_ini              !
    REAL(dp), DIMENSION(:,:,:), ALLOCATABLE ::   hc_loc_ini, sc_loc_ini, e3t_ini  !
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
+#  include "domvvl_ftrans.h90"
+!FTRANS hc_loc_ini sc_loc_ini e3t_ini :I :I :z
 
    !! * Substitutions
@@ -64,5 +74,5 @@
       INTEGER, INTENT(in) ::   kt   ! ocean time-step index
       !!
-      INTEGER    ::   jk                          ! dummy loop indice
+      INTEGER    ::   ji, jj, jk                  ! dummy loop indices
       REAL(dp)   ::   zdiff_hc    , zdiff_sc      ! heat and salt content variations
       REAL(dp)   ::   zdiff_v1    , zdiff_v2      ! volume variation
@@ -98,4 +108,26 @@
       zdiff_hc = 0.d0
       zdiff_sc = 0.d0
+#if defined key_z_first
+      ! volume variation (calculated with ssh)
+      zdiff_v1 = SUM( surf(:,:) * tmask_1(:,:) * ( sshn(:,:) - ssh_ini(:,:) ) )
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            DO jk = 1, jpkm1
+               ! volume variation (calculated with scale factors)
+               zdiff_v2 = zdiff_v2 + ( surf(ji,jj) * tmask(ji,jj,jk)    &
+                  &                       * ( fse3t_n(ji,jj,jk)         &
+                  &                           - e3t_ini(ji,jj,jk) ) ) 
+               ! heat content variation
+               zdiff_hc = zdiff_hc + ( surf(ji,jj) * tmask(ji,jj,jk)             &
+                  &                       * ( fse3t_n(ji,jj,jk) * tn(ji,jj,jk)   &
+                  &                           - hc_loc_ini(ji,jj,jk) ) )
+               ! salt content variation
+               zdiff_sc = zdiff_sc + ( surf(ji,jj) * tmask(ji,jj,jk)             &
+                  &                       * ( fse3t_n(ji,jj,jk) * sn(ji,jj,jk)   &
+                  &                           - sc_loc_ini(ji,jj,jk) ) )
+            END DO
+         END DO
+      END DO
+#else
       ! volume variation (calculated with ssh)
       zdiff_v1 = SUM( surf(:,:) * tmask(:,:,1) * ( sshn(:,:) - ssh_ini(:,:) ) )
@@ -114,5 +146,5 @@
             &                           - sc_loc_ini(:,:,jk) ) )
       ENDDO
-
+#endif
       IF( lk_mpp ) THEN
          CALL mpp_sum( zdiff_hc )
@@ -156,7 +188,7 @@
       !!             - Compute coefficients for conversion
       !!---------------------------------------------------------------------------
-      CHARACTER (len=32) ::   cl_name  ! output file name
-      INTEGER            ::   jk       ! dummy loop indice
-      INTEGER            ::   ierror   ! local integer
+      CHARACTER (len=32) ::   cl_name      ! output file name
+      INTEGER            ::   ji, jj, jk   ! dummy loop indices
+      INTEGER            ::   ierror       ! local integer
       !!
       NAMELIST/namhsb/ ln_diahsb
@@ -209,5 +241,9 @@
       ENDIF
       cl_name    = 'heat_salt_volume_budgets.txt'                         ! name of output file
+#if defined key_z_first
+      surf(:,:) = e1t(:,:) * e2t(:,:) * tmask_1(:,:) * tmask_i(:,:)      ! masked surface grid cell area
+#else
       surf(:,:) = e1t(:,:) * e2t(:,:) * tmask(:,:,1) * tmask_i(:,:)      ! masked surface grid cell area
+#endif
       surf_tot  = SUM( surf(:,:) )                                       ! total ocean surface area
       vol_tot   = 0.d0                                                   ! total ocean volume
@@ -249,4 +285,13 @@
       ! ---------------------------------- !
       ssh_ini(:,:) = sshn(:,:)                               ! initial ssh
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            e3t_ini   (ji,jj,:) = fse3t_n(ji,jj,:)                 ! initial vertical scale factors
+            hc_loc_ini(ji,jj,:) = tn(ji,jj,:) * fse3t_n(ji,jj,:)   ! initial heat content
+            sc_loc_ini(ji,jj,:) = sn(ji,jj,:) * fse3t_n(ji,jj,:)   ! initial salt content
+         END DO
+      END DO
+#else
       DO jk = 1, jpk
          e3t_ini   (:,:,jk) = fse3t_n(:,:,jk)                ! initial vertical scale factors
@@ -254,4 +299,5 @@
          sc_loc_ini(:,:,jk) = sn(:,:,jk) * fse3t_n(:,:,jk)   ! initial salt content
       END DO
+#endif
       frc_v = 0.d0                                           ! volume       trend due to forcing
       frc_t = 0.d0                                           ! heat content   -    -   -    -   
